#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <termios.h>
#include <string.h>
#include <unistd.h>
#include <stdint.h>
#include <time.h>
#include "../protocols.h"

void read_all(int fd, char *buffer, int len){
	int rcv_num = 0;
	while (rcv_num<len)
		rcv_num += usb_read(fd, buffer+rcv_num,len-rcv_num);
}

int usb_read(int fd, char *buffer, int len){
	int ret;
	int i=0;
	struct timespec req={0}, rem={0};
	time_t sec=(int)(1/1000);
	req.tv_sec=0;
	req.tv_nsec=1000000;
	while((ret=read(fd, buffer, len))==-1){
		i++;
		if(i>10000){
			printf("timeout expired\n");
			exit(1);
		}
		nanosleep(&req, &rem);
	}
	return ret;
}

int main(int argc,char** argv)
{
	uint8_t buff[50];
	uint32_t value;
	int i;

        struct termios tio;
        struct termios stdio;
        int tty_fd;
        fd_set rdset;
	uint32_t temp, check;
	unsigned char ch;
	int rv;
 
        unsigned char c='D';
 
        printf("Please start with %s /dev/ttyS1 (for example)\n",argv[0]);
/*       
	 memset(&stdio,0,sizeof(stdio));
        stdio.c_iflag=0;
        stdio.c_oflag=0;
        stdio.c_cflag=0;
        stdio.c_lflag=0;
        stdio.c_cc[VMIN]=1;
        stdio.c_cc[VTIME]=0;
        tcsetattr(STDOUT_FILENO,TCSANOW,&stdio);
        tcsetattr(STDOUT_FILENO,TCSAFLUSH,&stdio);
*/
        fcntl(STDIN_FILENO, F_SETFL, NULL); //O_NONBLOCK);       // make the reads non-blocking
 
 
 
 
        memset(&tio,0,sizeof(tio));
        tio.c_iflag=0;
        tio.c_oflag=0;
        tio.c_cflag=CS8|CREAD|CLOCAL;           // 8n1, see termios.h for more information
        tio.c_lflag=0;
        tio.c_cc[VMIN]=1;
        tio.c_cc[VTIME]=5;
 
        tty_fd=open(argv[1], O_RDWR ); //| O_NONBLOCK);      
        cfsetospeed(&tio,B115200);            // 115200 baud
        cfsetispeed(&tio,B115200);            // 115200 baud
 
        tcsetattr(tty_fd,TCSANOW,&tio);


	//GPIO LED ON
	buff[0] = PROTOCOL_GPIO;
	buff[1] = PORT0;
	buff[2] = OPERATION_DIR | OPERATION_SC | OPERATION_VAL;
	memset(buff+3, 0, 4);
	value = 0x00000400;
	memcpy(buff+7, &value, 4);
	memcpy(buff+11, &value, 4);
	memset(buff+15, 0, 4);
	write(tty_fd, buff, 19);
	read_all(tty_fd, buff, 5);
	printf("gpio ack for request: %x\n", (int)buff[0]);
	printf("buff[1]: %x, buff[2]: %x\n", (int)buff[1], (int)buff[2]);
	printf("buff[3]: %x, buff[4]: %x\n", (int)buff[3], (int)buff[4]);




	buff[0] = PROTOCOL_I2C;
 	buff[1] = 0x90;
	buff[2] = 0x03;
	buff[3] = 0x00;
        buff[4] = 0x03;
        buff[5] = 0x01;
        buff[6] = 0x0E;
	write(tty_fd, buff, 7); //finished setting OSADDR
	
	read_all(tty_fd, buff, 1);
	printf("after read 1\n");
	printf("request num is: %x\n", (int)buff[0]);
	read_all(tty_fd, buff, 2);
	printf("after read 2\n");
	printf("buff[0]: %x, buff[1]: %x\n", (int)buff[0], (int)buff[1]);
	
        buff[0] = PROTOCOL_I2C;
        buff[1] = 0x90;
        buff[2] = 0x03;
        buff[3] = 0x00;
        buff[4] = 0x02;
        buff[5] = 0x01;
        buff[6] = 0x08;
        write(tty_fd, buff, 7); //finished setting OSADDR

	read_all(tty_fd, buff, 1);
	printf("after read 1\n");
        printf("request num is: %x\n", (int)buff[0]);
        read_all(tty_fd, buff, 2);
	printf("after read 2\n");
        printf("buff[0]: %x, buff[1]: %x\n", (int)buff[0], (int)buff[1]);

        buff[0] = PROTOCOL_I2C;
        buff[1] = 0x90;
        buff[2] = 0x01;
        buff[3] = 0x02;
        buff[4] = 0x00;
        write(tty_fd, buff, 5); //finished setting OSADDR

        read_all(tty_fd, buff, 1);
	printf("after read 1\n");
        printf("request num is: %x\n", (int)buff[0]);
        read_all(tty_fd, buff, 2);
	printf("after read 2\n");
        printf("buff[0]: %x, buff[1]: %x\n", (int)buff[0], (int)buff[1]);
        read_all(tty_fd, buff+2, 2);
	printf("after read 2\n");
        printf("buff[0]: %x, buff[1]: %x\n", (int)buff[2], (int)buff[3]);

        temp = buff[2];
        temp <<= 1;
        check = ((buff[3] & 0x80) >> 7);
        printf("check: %d\n", check);
        temp |= check;
        printf("buf2: %x buf3: %x  temp: %f\n", (int) buff[2], (int) buff[3], ((float)temp)/2);



	printf("sleeping 2 sec\n");
	sleep(2);
	//GPIO LED OFF
	buff[0] = PROTOCOL_GPIO;
	buff[1] = PORT0;
	buff[2] = OPERATION_SC;
	memset(buff+3, 0, 4);
	memcpy(buff+7, &value, 4);
	write(tty_fd, buff, 11);
	read_all(tty_fd, buff, 1);
	printf("gpio ack for request: %x\n", (int)buff[0]);

/*
	buff[0] = 0x03;
	buff[1] = 0x01;
	buff[2] = 0x0E;

	ch = PROTOCOL_I2C;
	write(tty_fd, &ch, 1); //define protocol
	ch = 0x90;
	write(tty_fd, &ch, 1); //define i2c sensor address
	ch = 0x03<<1;
	write(tty_fd, &ch, 1); //define numBytes and write operation
	
	//set HYSTADDR
	ch = 0x03<<1;
	write(tty_fd, &ch, 1);
	buff[0] = 0x02;
	buff[1] = 0x01;
	buff[2] = 0x08;
	write(tty_fd, buff, 3);
	
	//set pointer register to TEMPADDR
	ch = 0x01<<1;
	write(tty_fd, &ch, 1);
	buff[0] = 0x00;
	write(tty_fd, buff, 1);
*/
	
	/*	
	while(1)
        {
                if (read(tty_fd,&c,1)>0)        write(STDOUT_FILENO,&c,1);              // if new data is available on the serial port, print it out
                if (read(STDIN_FILENO,&c,1)>0)  write(tty_fd,&c,1);                     // if new data is available on the console, send it to the serial port
        }
	*/
 
        close(tty_fd);
}

